#!/bin/bash

# Autore:   Gianpaolo Lucatti
# E-mail:   sportegioco@gmail.com
# Sito web: http://www.sportegioco.it

### Queste due righe successive sono obbligatorie
echo "Content-type: text/html"
echo ""
### Prende i parametri dal form con il metodo POST o GET indifferenziato
#query="stringaricerca=home+paolo+%22mario+giorgio%22&send=Cerca&optricerca=locate&optignorecase=ignorecase&optlimit=100&sceltafile= "
function get_parameter ()
{
  echo "$query" | tr '&' '\n' | grep "^$1=" | head -1  | sed "s/.*=//"   # esiste anche un programmino scritto in c per | urldecode
}

if [ "$REQUEST_METHOD" = POST ]; then
     query=$( head --bytes="$CONTENT_LENGTH" )
else
     query="$QUERY_STRING"
fi
### Decodifica la stringa del POST o del GET ricambiando caratteri +, %, ecc.
function urldecode() { echo -e $( echo "$@" | sed -e 's/+/ /g;s/%/\\x/g' ); }

stringaricerca=$( get_parameter stringaricerca )
optricerca=$( get_parameter optricerca )
optlimit=$( get_parameter optlimit )
optignorecase=$( get_parameter optignorecase )
optsolobasename=$( get_parameter optsolobasename )
sceltafile=$( get_parameter sceltafile )
stringaricercaurldecoded=$( urldecode $stringaricerca )   #paolo+mario+%22luigi%22
sceltafileurldecoded="$( urldecode $sceltafile )"


### INIZIO Scrivo tutta la parte di testo che va nell'head
echo '<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">'
echo '<html><head>
  <meta http-equiv="content-type"  content="text/html; charset=UTF-8">
  <style type="text/css">
:root {
font-family: sans-serif;
background-color: -moz-dialog;
color: -moz-dialogtext;
font: message-box;
padding-left: 2em;
padding-right: 2em;
}
img {
border: 0;
}
th {
text-align: left;
white-space: nowrap;
}
th > a {
color: inherit;
}
table[order] > thead > tr > th {
cursor: pointer;
}
table[order] > thead > tr > th::after {
display: none;
width: .8em;
-moz-margin-end: -.8em;
text-align: right;
}
table[order="asc"] > thead > tr > th::after {
content: "\2193"; /* DOWNWARDS ARROW (U+2193) */
}
table[order="desc"] > thead > tr > th::after {
content: "\2191"; /* UPWARDS ARROW (U+2191) */
}
table[order][order-by="0"] > thead > tr > th:first-child > a ,
table[order][order-by="1"] > thead > tr > th:first-child + th > a ,
table[order][order-by="2"] > thead > tr > th:first-child + th + th > a {
text-decoration: underline;
}
table[order][order-by="0"] > thead > tr > th:first-child::after ,
table[order][order-by="1"] > thead > tr > th:first-child + th::after ,
table[order][order-by="2"] > thead > tr > th:first-child + th + th::after {
display: inline-block;
}
table.remove-hidden > tbody > tr.hidden-object {
display: none;
}
td > a {
display: inline-block;
}
/* name */
th:first-child {
-moz-padding-end: 2em;
}
/* size */
th:first-child + th {
-moz-padding-end: 1em;
}
td:first-child + td {
text-align: right;
-moz-padding-end: 1em;
white-space: nowrap;
}
/* date */
td:first-child + td + td {
-moz-padding-start: 1em;
-moz-padding-end: .5em;
white-space: nowrap;
}
/* time */
td:last-child {
-moz-padding-start: .5em;
white-space: nowrap;
}
@-moz-document url-prefix(gopher://) {
td {
white-space: pre !important;
font-family: monospace;
}
}
.symlink {
font-style: italic;
}
.dir ,
.symlink ,
.file {
-moz-margin-start: 20px;
}
.dir::before ,
.file > img {
-moz-margin-end: 4px;
-moz-margin-start: -20px;
vertical-align: middle;
}
.dir::before {
content: url(resource://gre/res/html/folder.png);
}
body {
border: 1px solid ThreeDShadow;
-moz-border-radius: 10px;
padding: 3em;
min-width: 30em;
max-width: 65em;
margin: 4em auto;
background-color: -moz-field;
color: -moz-fieldtext;
}
h1 {
font-size: 160%;
margin: 0 0 .6em;
border-bottom: 1px solid ThreeDLightShadow;
font-weight: normal;
}
a {
text-decoration: none;
}
a:hover {
text-decoration: underline;
}
p {
font-size: 110%;
}
#UI_goUp {
margin-top: 0;
float: left;
}
#UI_showHidden {
margin-top: 0;
float: right;
}
table {
clear: both;
width: 90%;
margin: 0 auto;
}
thead {
font-size: 130%;
}
/* last modified */
th:last-child {
text-align: center;
}
th:hover > a {
text-decoration: underline;
}
tbody > tr:hover {
outline: 1px solid ThreeDLightShadow;
-moz-outline-radius: .3em;
}
/* let Size and Last Modified take only as much space as they need and Name all the rest */
td:not(:first-child) {
width: 0;
}
.up {
padding: 0 .5em;
-moz-margin-start: 20px;
}
.up::before {
-moz-margin-end: 4px;
-moz-margin-start: -20px;
vertical-align: middle;
content: url(moz-icon://stock/gtk-go-up?size=menu);
}
.dir::before {
content: url(moz-icon://stock/gtk-directory?size=menu);
}
  </style>
  <script type="application/javascript">
var gTable, gOrderBy, gTBody, gRows, gUI_showHidden;
document.addEventListener("DOMContentLoaded", function() {
gTable = document.getElementsByTagName("table")[0];
gTBody = gTable.tBodies[0];
if (gTBody.rows.length < 2)
return;
gUI_showHidden = document.getElementById("UI_showHidden");
var headCells = gTable.tHead.rows[0].cells,
hiddenObjects = false;
function rowAction(i) {
return function(event) {
event.preventDefault();
orderBy(i);
}
}
for (var i = headCells.length - 1; i >= 0; i--) {
var anchor = document.createElement("a");
anchor.href = "";
anchor.appendChild(headCells[i].firstChild);
headCells[i].appendChild(anchor);
headCells[i].addEventListener("click", rowAction(i), true);
}
if (gUI_showHidden) {
gRows = Array.slice(gTBody.rows);
hiddenObjects = gRows.some(function (row) row.className == "hidden-object");
}
gTable.setAttribute("order", "");
if (hiddenObjects) {
gUI_showHidden.style.display = "block";
updateHidden();
}
}, "false");
function compareRows(rowA, rowB) {
var a = rowA.cells[gOrderBy].getAttribute("sortable-data") || "";
var b = rowB.cells[gOrderBy].getAttribute("sortable-data") || "";
var intA = +a;
var intB = +b;
if (a == intA && b == intB) {
a = intA;
b = intB;
} else {
a = a.toLowerCase();
b = b.toLowerCase();
}
if (a < b)
return -1;
if (a > b)
return 1;
return 0;
}
function orderBy(column) {
if (!gRows)
gRows = Array.slice(gTBody.rows);
var order;
if (gOrderBy == column) {
order = gTable.getAttribute("order") == "asc" ? "desc" : "asc";
} else {
order = "asc";
gOrderBy = column;
gTable.setAttribute("order-by", column);
gRows.sort(compareRows);
}
gTable.removeChild(gTBody);
gTable.setAttribute("order", order);
if (order == "asc")
for (var i = 0; i < gRows.length; i++)
gTBody.appendChild(gRows[i]);
else
for (var i = gRows.length - 1; i >= 0; i--)
gTBody.appendChild(gRows[i]);
gTable.appendChild(gTBody);
}
function updateHidden() {
gTable.className = gUI_showHidden.getElementsByTagName("input")[0].checked ?
"" :
"remove-hidden";
}
</script>
<link rel="icon" type="image/png" href="data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8%2F9hAAAAGXRFWHRTb2Z0d2FyZQBBZG9iZSBJbWFnZVJlYWR5ccllPAAAAjFJREFUeNqsU8uOElEQPffR3XQ3ONASdBJCSBxHos5%2B3Bg3rvkCv8PElS78gPkO%2FATjQoUdO2ftrJiRh6aneTb9sOpC4weMN6lcuFV16pxDIfI8x12OYIDhcPiu2Wx%2B%2FHF5CW1Z6Jyegt%2FTNEWSJIjjGFEUIQxDrFYrWFSzXC4%2FdLvd95pRKpXKy%2BpRFZ7nwaWo1%2BsGnQG2260BKJfLKJVKGI1GEEJw7ateryd0v993W63WEwjgxfn5obGYzgCbzcaEbdsIggDj8Riu6z6iUk9SYZMSx8W0LMsM%2FSKK75xnJlIq80anQXdbEp0OhcPJ0eiaJnGRMEyyPDsAKKUM9clkYoDo3SZJzzSdp0VSKYmfV1co%2Bz580kw5KDIM8RbRfEnUf1HzxtQyMAGcaGruTKczMzEIaqhKifV6jd%2BzGQQB5llunF%2FM52BizC2K5sYPYvZcu653tjOM9O93wnYc08gmkgg4VAxixfqFUJT36AYBZGd6PJkFCZnnlBxMp38gqIgLpZB0y4Nph18lyWh5FFbrOSxbl3V4G%2BVB7T4ajYYxTyuLtO%2BCvWGgJE1Mc7JNsJEhvgw%2FQV4fo%2F24nbEsX2u1d5sVyn8sJO0ZAQiIYnFh%2BxrfLz%2Fj29cBS%2FO14zg3i8XigW3ZkErDtmKoeM%2BAJGRMnXeEPGKf0nCD1ydvkDzU9Jbc6OpR7WIw6L8lQ%2B4pQ1%2FlPF0RGM9Ns91Wmptk0GfB4EJkt77vXYj%2F8m%2B8y%2FkrwABHbz2H9V68DQAAAABJRU5ErkJggg%3D%3D">
<title>Ricerca: '$stringaricerca'</title>
</head><body>
'
### FINE Scrivo tutta la parte di testo che va nell'head

### Attiva i messaggi di debug
debug="no"
if [ "$debug" = "si" ]; then
echo "stringaquery=$query"
echo "<br>"
echo "stringaricerca=$stringaricerca"
echo "<br>"
echo "optlimit=$optlimit"
echo "<br>"
echo "optignorecase=$optignorecase"
echo "<br>"
echo "optbasename=$basename"
echo "<br>"
echo "stringaricercaurldecoded=$stringaricercaurldecoded"
echo "<br>"
echo "optricerca=$optricerca"
echo "<br>"
echo "sceltafile=$sceltafile"
echo "<br>"
fi

### INIZIO Scrivo tutta la parte di testo iniziale che va nel body    <img src="http://localhost/mymy.png">
echo '
<center>
<img src="data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAASkAAACABAMAAACl04IjAAAAAXNSR0IArs4c6QAAABJQTFRFABgA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%0Agg==">
<form method="POST" action="">
<input type="text" name="stringaricerca" size="40" value='\"$stringaricercaurldecoded\"'>
<input type="submit" name="send" value="Cerca"><br>
|< Cerca: <input type="radio" '$(if [ "$optricerca" = "locate" ] || [ "$optricerca" = "" ]; then  echo "checked=\"checked\"" ; fi)' value="locate" name="optricerca"> con Locate | <input type="radio" '$(if [ "$optricerca" = "grep" ]; then  echo "checked=\"checked\"" ; fi)'  value="grep" name="optricerca"> nei miei Cataloghi | <input type="radio"  '$(if [ "$optricerca" = "find" ]; then  echo "checked=\"checked\"" ; fi)'  value="find" name="optricerca"> con Find >|<br>|< <input type="checkbox"  '$(if [ "$query" = "" ]  || [ "$optignorecase" != "" ]; then  echo "checked=\"checked\"" ; fi)'  value="ignorecase" name="optignorecase"> Ignora Maiuscole/Minuscole >|< <input type="checkbox"  '$(if  [ "$query" = "" ]  || [ "$optsolobasename" = "basename" ]; then  echo "checked=\"checked\"" ; fi)'  value="basename" name="optsolobasename"> Cerca solo nel nome di file/cartelle, no path >|< Max n° risultati <input type="text" name="optlimit" size="2" value="'$(if [ "$optlimit" = "" ]; then  echo "100" ; else echo "$optlimit" ; fi)'"> 0 = No Limit >|<br>
A partire dal path (Solo con Find): <input type="file" name="sceltafile" size="60" value="'$(echo "$sceltafileurldecoded")'"> 
</form>
</center> 
'
### FINE Scrivo tutta la parte di testo iniziale che va nel body

mydatabasefilepath="/var/lib/mymysearch/mymysearchdatabase.db"  #Se con l'opzione database grep deve cercare in un solo file
#mydatabasedirpath=""                            #Se con l'opzione database grep deve cercare in tutti i file presenti in una cartella
#optricerca="grep"    #locate | grep | find     #optricerca=$( get_parameter optricerca )  # servirà dopo per decidere quale comando utilizzare

  case "$optricerca" in
    "locate")
      comandoricerca="locate"
      ;;
    "grep")
      comandoricerca="grep"
      ;;
    "find")
      comandoricerca="find"
      ;;
  esac

#echo $comandoricerca
#Conta le parole da ricercare

stringaricerca="$stringaricercaurldecoded"

numerodiparoledacercare="0"
for i in $stringaricerca
do
numerodiparoledacercare="$[$numerodiparoledacercare +1]"
done
#echo "Il numero di parole da ricercare è uguale a $numerodiparoledacercare"

argomentiricerca=""    #Argomenti che vanno bene per tutti e tre i primi comandi (locate, grep, find)
argomentigrep=""       #Argomenti che vanno bene tutti i grep compreso l'ultimo
argomentiultimogrep="" #Argomenti che vanno bene solo per l'ultimo grep, cioè quello che regola l'output finale

#optignorecase="ignorecase"   #ignora le differenze maiuscolo e minuscolo - ignore-case - predefinito
     if [ "$optignorecase" = "ignorecase" ]  && [ "$optricerca" = "locate" ] ; then
          argomentiricerca=$argomentiricerca" -i"
          argomentigrep=$argomentigrep" -i"        #Questo è per tutti i grep
     elif [ "$optignorecase" = "ignorecase" ]  && [ "$optricerca" = "grep" ] ; then
          argomentiricerca=$argomentiricerca" -i"  #Questo è per il primo grep
          argomentigrep=$argomentigrep" -i"        #Questo è per tutti i grep
     fi

#optsolobasename="basename"   #Cerca solo nel nome del file
     if [ "$optsolobasename" = "basename" ] && [ "$optricerca" = "locate" ] ; then
          argomentiricerca=$argomentiricerca" -b"
     fi

#optlimit="100"   #Limita la ricerca al numero di occorrenze scelto
       if [ "$optlimit" -eq "0" ]; then
          echo ""
     elif [ "$optlimit" != "" ] && [ "$optricerca" = "locate" ] && [ "$numerodiparoledacercare" -eq "1" ]; then
          argomentiricerca=$argomentiricerca" -l $optlimit "
     elif [ "$optlimit" != "" ] && [ "$optricerca" = "grep" ] && [ "$numerodiparoledacercare" -eq "1" ]; then
          argomentiricerca=$argomentiricerca" -m $optlimit "        #Questo è per il primo grep nel caso di una sola parola
     elif [ "$optlimit" != "" ] && [ "$numerodiparoledacercare" -gt "1" ]; then
          argomentiultimogrep=$argomentiultimogrep" -m $optlimit "  #Questo è per l'ultimo grep nel caso di più parole
     fi

#++++ INIZIO TUTTA LA PROCEDURA DI RICERCA DELLE PAROLE UTILIZZANDO GREP +++++++++

contatore="0"
for i in $stringaricerca
do
parola=$(echo $i)
#echo "xxxxxxxxxxxx Il valore del contatore è $contatore"

     if [ "$optsolobasename" = "basename" ] && [ "$optricerca" = "grep" ] ; then
          parola=""$parola""[^\/]*\$""
     fi

     if [ "$optsolobasename" = "basename" ] && [ "$optricerca" = "locate" ] && [ "$contatore" -gt "0" ]; then
          parola=""$parola""[^\/]*\$""
     fi

     if [ "$contatore" -eq "0" ]  && [ "$optricerca" = "locate" ]; then
     comandoricerca=""$comandoricerca" "$argomentiricerca" "$parola""
     #echo "0000 - Il comandoricerca è: $comandoricerca" 
     #fi

     elif [ "$contatore" -eq "0" ]  && [ "$optricerca" = "grep" ]; then
     comandoricerca=""$comandoricerca" "$argomentiricerca" "$parola" "$mydatabasefilepath""
     #echo "0000 - Il comandoricerca è: $comandoricerca" 
     #fi

     elif [ "$contatore" -eq "$[$numerodiparoledacercare -1]" ] ; then  #Se è l'ultimo parola uso gli argomentigrep e gli argomentiultimogrep
     comandoricerca=""$comandoricerca" | "grep" "$argomentigrep" "$argomentiultimogrep" "$parola""
     #echo "1111 - Il argomentiricerca è: $argomentiricerca" 
     #fi

     elif [ "$contatore" -gt "0" ] ; then  #Se non è l'ultimo grep non uso gli argomentigrep
     comandoricerca=""$comandoricerca" | "grep" "$argomentigrep" "$parola""
     #echo "2222 - Il argomentiricerca è: $argomentiricerca" 
     fi

#echo "la parola $contatore è $parola"
#echo "la stringaricerca è  $stringaricerca"
contatore="$[$contatore +1]"
#echo "yyyyyyyyyyyy Il valore del contatore è $contatore"
done

#echo "Il numero di parole da ricercare è uguale a $contatore"
#echo "Il comando ricerca è: $comandoricerca"
#echo "Gli argomentiricerca sono: $argomentiricerca"
#echo "Gli argomentigrep sono: $argomentigrep"
#echo "Gli argomentiultimogrep sono: $argomentiultimogrep"

echo "Il comando ricerca appena eseguito è: $comandoricerca"

LINE=$(eval $comandoricerca)       #funziona nei comandi complessi eval valuta ed esegue il comando
    if [ "$LINE" != "" ] ; then
         numerodilinee=$(echo -e "$LINE" | sed -n '$=')       #funziona
         #echo "numerodilinee: $numerodilinee"   #stampa il numero di righe ma purtroppo dice 1 anche quando è vuota
    else
         numerodilinee="0"
         #echo "numerodilinee: $numerodilinee" 
    fi

#************* FINE PROCEDURA PER DEFINIRE IL COMANDO PER LA RICERCA CON GREP ***********

#************* INIZIO -  SCRIVO TUTTE LE RIGHE DELLA RICERCA NELLA TABELLA ***********
echo "<h2>Ricerca effettuata con i seguenti termini: -> $stringaricercaurldecoded <-</h2>" #>> /tmp/ricerca.html          #Aggiunge il testo alla fine del testo presente nel file
echo "<h3>Il numero di oggetti trovati corrisponde a: \"$numerodilinee\"</h2>" #>> /tmp/ricerca.html

echo '
<p id="UI_goUp"><a class="up" href="file:///">Vai alla cartella base del filesystem</a></p>
<p id="UI_showHidden" style="display: block;"><label><input checked="checked" onchange="updateHidden()" type="checkbox">Visualizza elementi nascosti</label></p>
<table class="" order="">

 <thead>
  <tr>
   <th><a href="">Nome</a></th>
   <th><a href="">Dimensione</a></th>
   <th colspan="2"><a href="">Ultima modifica</a></th>
  </tr>
 </thead>
 <tbody>
'
###echo -e "$testo" >> /tmp/ricerca.html                     #Aggiunge il testo alla fine del testo
#************* FINE - CREO IL FILE RICERCA.HTML E SCRIVO LE PRIME RIGHE ***********


for i in $(seq "1" "$numerodilinee");
    do

        #echo $i
        rigai=$(echo -e "$LINE" | sed -n $i'p')   #stampa la riga i
        hreffile="file://$rigai"
        #echo "hreffile riga $i: $hreffile"
        basenamefile=$(basename "$rigai")
        #echo "basenamefile riga $i: $basenamefile"

        if [ -r  "$rigai" ]; then  #Se il file esiste ed ha i permessi di lettura
          #echo "riga $i: $rigai"
          dirnamefile=$(dirname "$rigai")
          #echo "dirnamefile riga $i: $dirnamefile"
          classfile=$(file -b -L --mime-type "$rigai")   #stampa solo il mime-type senza il --mime-encoding Es. text-x-java   e non text-x-java charset=us-ascii e segue il link simbolico se presente (-L)
          #echo "classfile riga $i: $classfile"
          sortabledatafile=$(date +%s -r "$rigai")000000
          #echo "sortabledatafile riga $i: $sortabledatafile"
          datafile=$(date +%d/%m/%Y -r "$rigai")
          #echo "datafile riga $i: $datafile"
          orafile=$(date +%r -r "$rigai")
          #echo "orafile riga $i: $orafile"

    if [ "${basenamefile:0:1}" = "." ] ; then  #Estraggo il primo carattere del basename
         hiddenobject="class=\"hidden-object\""
    else
         hiddenobject=""
    fi
        #Imposta l'icona della directory o del file
          if [ "$classfile" = "application/x-directory" ] ; then
               sortablebasenamefile="1""$basenamefile"
               classfile="dir"
               sortabledimensionfile=""
               dimensionfile=""
testo='<tr '$hiddenobject'>
 <td sortable-data='\"$sortablebasenamefile\"'><a class='\"$classfile\"' href='\"$hreffile\"'><img src='\"$basenamefile\"'">'$basenamefile'</a>  <a  href="openlocal://'$hreffile'"> <span style="color: green;">(Apri Cartella)</span>     </a>   </td>
 <td sortable-data='\"$sortabledimensionfile\"'>'$dimensionfile'</td>
 <td sortable-data='\"$sortabledatafile\"'>'$datafile'</td>
 <td>'$orafile'</td>
</tr>'
          else
               sortablebasenamefile="2""$basenamefile"
               classfile="file"
               sortabledimensionfile=$(du -b "$rigai" | sed 's/[\t].*//')      #Uguale al comando: stat  -c%s "$rigai" 
               dimensionfile=$(du -h "$rigai" | sed 's/[\t].*//')
               #imgsrciconfile="$imgsrciconfile""$iconext"
               iconext="${basenamefile##*.}"    #Ricava l'estensione del file, cioè tutto ciò che viene dopo l'ultimo punto" 
testo='<tr '$hiddenobject'>
 <td sortable-data='\"$sortablebasenamefile\"'><a class='\"$classfile\"' href='\"$hreffile\"'><img src='"moz-icon://.$iconext?size=16"' alt="File:">'$basenamefile'</a>  <a  href="openlocal://'$hreffile'">  <span style="color: green;">(Apri File)</span>   </a> 
<a  href="openlocal://'$(dirname "$hreffile")'">  <span style="color: green;">(Apri Cartella)</span>   </a> </td>
 <td sortable-data='\"$sortabledimensionfile\"'>'$dimensionfile'</td>
 <td sortable-data='\"$sortabledatafile\"'>'$datafile'</td>
 <td>'$orafile'</td>
</tr>'
          fi

          echo -e "$testo" #>> /tmp/ricerca.html                     #Aggiunge il testo alla fine del file
        else
#$(echo -e "$basenamefile non esiste"
testo='<tr '$hiddenobject'>
 <td sortable-data="??"><a class="??" href='\"$hreffile\"'><img src='"moz-icon://.$iconext?size=16"' alt="File:">'$basenamefile'</a> <span style="color: red;">Non esiste o non è leggibile</span></td>
 <td sortable-data="??">??</td>
 <td sortable-data="??">??</td>
 <td>??</td>
</tr>'
        echo -e "$testo"  ##>> /tmp/ricerca.html                     #Aggiunge il testo alla fine del file
        fi
    done
#************* FINE - NEL FILE RICERCA.HTML SCRIVO TUTTE LE RIGHE DELLA RICERCA NELLA TABELLA ***********

                #Aggiunge il testo alla fine del file

echo "</tbody></table></body></html>"
